/*************************************************************************
 *                                                                        *
 *  perm - allow everything and make your Linux' protection useless       *
 *  Copyright (C) 2004 Philipp Hachtmann (hachti@hachti.de)               *
 *                                                                        *
 **************************************************************************
 *                                                                        *
 *  This program is free software; you can redistribute it and/or         *
 *  modify it under the terms of the GNU General Public License           *
 *  as published by the Free Software Foundation; either version 2        *
 *  of the License, or (at your option) any later version.                *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program; if not, write to the Free Software           *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                *
 *  MA  02111-1307, USA.                                                  *
 *                                                                        *
 **************************************************************************
 *                                                                        *
 *  ABOUT                                                                 *
 *  This program is a wrapper initially written for my tapeload program   *
 *  but it can be used with any ugly or evil program which wants to       *
 *  access the PC's hardware directly or do any other bad things.         *
 *  perm must be installed suid root, of course. And you should be        *
 *  VERY careful with the execution rights. Operation is simple:          *
 *  A program executed by perm can do everything - and even more.         *
 *                                                                        *
 **************************************************************************
 *                                                                        * 
 *   VERSION                                                              *
 *   2004-10-01 ver. 1.0 - Final                                          *
 *                                                                        * 
 *************************************************************************/

#include <stdio.h>
#include <sys/io.h>
#include <sys/types.h>
#include <sys/unistd.h>
#include <stdlib.h>


int main (int argc, char ** argv){
    
    if (argc < 2) {
        printf("\nperm - grant unlimited hardware access to programs.\n");
	printf("\nUsage:\nperm command [arg, arg, ... ]\n\n");
	exit(100);
    }

    if (geteuid()!=0) {
    	printf("You have to be root or suid the executable\nto screw up your system. cu.\n");
    	exit(110);
    }
    
    if (iopl(3)!=0) {
	printf("iopl() returned an error. Sorry.\n");
	exit(3);
    }
    if (setuid(0)!=0){
	printf("setuid() returned an error. Sorry.\n");
	exit(4);
    }
        
    printf("Executing: ");
    
    char ** newargs;
    int nasize;
    newargs=(char **) malloc ((argc)*sizeof(char *));
    int c;
    for (c=1; c< argc; c++){ 
	newargs[c-1]=argv[c];
	printf("%s ",argv[c]);
    }
    printf("\n");
    newargs[argc-1]=NULL;
    execvp(argv[1],newargs);
    printf("There was an error EXECing your command. Sorry.\n");
    return 77;
}
//---------------------------------
